Unbound TreeGrid

If you prefer to work in unbound mode, you can still build TreeGrids by adding rows and columns in code.

Learn about TreeGrid | Unbound TreeGrid Documentation | FlexGrid API Reference

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
app.js
index.html
styles.css
Copy to CodeMine
loading...
import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import * as wjGrid from '@mescius/wijmo.grid'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { // // workers tree data (heterogeneous collection) var workers = [{ name: 'Jack Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }, { name: 'Jack Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }, { name: 'Jane Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }]; // // unbound workers tree var uwt = new wjGrid.FlexGrid('#workersGrid', { headersVisibility: 'Column', selectionMode: 'Row', beginningEdit: function (s, e) { var value = e.panel.getCellData(e.row, e.col); if (value == null) { e.cancel = true; // can't edit! } } }); // // add columns uwt.columns.push(new wjGrid.Column({ header: 'Name' })); uwt.columns.push(new wjGrid.Column({ header: 'Hours', dataType: 'Number', format: 'n2' })); uwt.columns.push(new wjGrid.Column({ header: 'Rate', dataType: 'Number', format: 'n2' })); // // add rows for (var w = 0; w < workers.length; w++) { // // add worker var worker = workers[w]; var row = new wjGrid.GroupRow(); row.dataItem = worker; row.isReadOnly = false; row.level = 0; uwt.rows.push(row); uwt.setCellData(row.index, 0, worker.name); for (var c = 0; c < worker.checks.length; c++) { // // add check var check = worker.checks[c]; row = new wjGrid.GroupRow(); row.dataItem = check; row.isReadOnly = false; row.level = 1; uwt.rows.push(row); uwt.setCellData(row.index, 0, check.name); for (var e = 0; e < check.earnings.length; e++) { // // add earning var earning = check.earnings[e]; row = new wjGrid.GroupRow(); row.dataItem = earning; row.isReadOnly = false; row.level = 2; uwt.rows.push(row); uwt.setCellData(row.index, 0, earning.name); uwt.setCellData(row.index, 1, earning.hours); uwt.setCellData(row.index, 2, earning.rate); // } } } }
import 'bootstrap.css'; import '@mescius/wijmo.styles/wijmo.css'; import './styles.css'; import * as wjGrid from '@mescius/wijmo.grid'; // document.readyState === 'complete' ? init() : window.onload = init; // function init() { // // workers tree data (heterogeneous collection) var workers = [{ name: 'Jack Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }, { name: 'Jack Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }, { name: 'Jane Smith', checks: [{ name: 'check1', earnings: [ { name: 'hourly', hours: 30.0, rate: 15.0 }, { name: 'overtime', hours: 10.0, rate: 20.0 }, { name: 'bonus', hours: 5.0, rate: 30.0 } ] }, { name: 'check2', earnings: [ { name: 'hourly', hours: 20.0, rate: 18.0 }, { name: 'overtime', hours: 20.0, rate: 24.0 } ] }] }]; // // unbound workers tree var uwt = new wjGrid.FlexGrid('#workersGrid', { headersVisibility: 'Column', selectionMode: 'Row', beginningEdit: function (s, e) { var value = e.panel.getCellData(e.row, e.col); if (value == null) { e.cancel = true; // can't edit! } } }); // // add columns uwt.columns.push(new wjGrid.Column({ header: 'Name' })); uwt.columns.push(new wjGrid.Column({ header: 'Hours', dataType: 'Number', format: 'n2' })); uwt.columns.push(new wjGrid.Column({ header: 'Rate', dataType: 'Number', format: 'n2' })); // // add rows for (var w = 0; w < workers.length; w++) { // // add worker var worker = workers[w]; var row = new wjGrid.GroupRow(); row.dataItem = worker; row.isReadOnly = false; row.level = 0; uwt.rows.push(row); uwt.setCellData(row.index, 0, worker.name); for (var c = 0; c < worker.checks.length; c++) { // // add check var check = worker.checks[c]; row = new wjGrid.GroupRow(); row.dataItem = check; row.isReadOnly = false; row.level = 1; uwt.rows.push(row); uwt.setCellData(row.index, 0, check.name); for (var e = 0; e < check.earnings.length; e++) { // // add earning var earning = check.earnings[e]; row = new wjGrid.GroupRow(); row.dataItem = earning; row.isReadOnly = false; row.level = 2; uwt.rows.push(row); uwt.setCellData(row.index, 0, earning.name); uwt.setCellData(row.index, 1, earning.hours); uwt.setCellData(row.index, 2, earning.rate); // } } } }
<!DOCTYPE html> <html lang="en"> <head> <meta charset="utf-8"> <meta http-equiv="X-UA-Compatible" content="IE=edge"> <title>MESCIUS Wijmo FlexGrid Unbound Tree Grid</title> <meta name="viewport" content="width=device-width, initial-scale=1.0"> <!-- SystemJS --> <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app'); </script> </head> <body> <main class="container-fluid"> <div id="workersGrid"></div> </main> </body> </html>
.wj-flexgrid { max-height: 220px; margin: 10px; } .wj-cell.wj-group { border: none; } .wj-cell.wj-group:not(.wj-state-selected):not(.wj-state-multi-selected) { background-color: white; } body { margin-bottom: 24px; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'jszip': 'npm:jszip/dist/jszip.js', '@mescius/wijmo': 'npm:@mescius/wijmo/index.js', '@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js', '@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles', '@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures', '@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js', '@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js', '@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js', '@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js', '@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js', '@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js', '@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js', '@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js', '@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js', '@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js', '@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js', '@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js', '@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js', '@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js', '@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js', '@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js', '@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js', '@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js', '@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js', '@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js', '@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js', '@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js', '@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js', '@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js', '@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js', '@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js', '@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js', '@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js', '@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js', '@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js', '@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js', '@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js', '@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js', '@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js', '@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js', '@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js', '@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js', '@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js', '@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js', '@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js', '@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js', '@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js', '@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

<template>
<main class="container-fluid">
<wj-flex-grid headers-visibility="Column" selection-mode="Row" :beginningEdit="onBeginningEdit"
:initialized="initialGrid">
</wj-flex-grid>
</main>
</template>
<script setup>
import * as wjcGrid from "@mescius/wijmo.grid";
import { getWorkers } from "./data";
import { ref, onMounted } from "vue";
null;
const workersGrid = ref(null);
onMounted(function () {
let workers = getWorkers();
// add columns
workersGrid.value.columns.push(new wjcGrid.Column({ header: "Name" }));
workersGrid.value.columns.push(new wjcGrid.Column({ header: "Hours", dataType: "Number", format: "n2" }));
workersGrid.value.columns.push(new wjcGrid.Column({ header: "Rate", dataType: "Number", format: "n2" }));
// add rows
for (let w = 0; w < workers.length; w++) {
// add worker
let worker = workers[w];
let row = new wjcGrid.GroupRow();
row.dataItem = worker;
row.isReadOnly = false;
row.level = 0;
workersGrid.value.rows.push(row);
workersGrid.value.setCellData(row.index, 0, worker.name);
for (let c = 0; c < worker.checks.length; c++) {
// add check
let check = worker.checks[c];
row = new wjcGrid.GroupRow();
row.dataItem = check;
row.isReadOnly = false;
row.level = 1;
workersGrid.value.rows.push(row);
workersGrid.value.setCellData(row.index, 0, check.name);
for (let e = 0; e < check.earnings.length; e++) {
// add earning
let earning = check.earnings[e];
row = new wjcGrid.GroupRow();
row.dataItem = earning;
row.isReadOnly = false;
row.level = 2;
workersGrid.value.rows.push(row);
workersGrid.value.setCellData(row.index, 0, earning.name);
workersGrid.value.setCellData(row.index, 1, earning.hours);
workersGrid.value.setCellData(row.index, 2, earning.rate);
}
}
}
});
function initialGrid(grid) {
workersGrid.value = grid;
}
function onBeginningEdit(flexGird, e) {
let value = e.panel.getCellData(e.row, e.col, true);
if (value == null) {
e.cancel = true; // can't edit!
}
}
</script>
<style>
.wj-flexgrid {
max-height: 220px;
margin: 10px;
}
.wj-cell.wj-group {
border: none;
}
.wj-cell.wj-group:not(.wj-state-selected):not(.wj-state-multi-selected) {
background-color: white;
}
body {
margin-bottom: 24px;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Unbound Tree Grid</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getWorkers() {
return [{
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jane Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}];
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjcGrid from '@mescius/wijmo.react.grid';
import * as wjGrid from '@mescius/wijmo.grid';
import './app.css';
import { workers } from './data';
function App() {
const workersGridRef = useRef(null);
const initialGrid = useEvent((grid) => {
workersGridRef.current = grid;
// add columns
workersGridRef.current.columns.push(new wjGrid.Column({ header: 'Name' }));
workersGridRef.current.columns.push(new wjGrid.Column({ header: 'Hours', dataType: 'Number', format: 'n2' }));
workersGridRef.current.columns.push(new wjGrid.Column({ header: 'Rate', dataType: 'Number', format: 'n2' }));
// add rows
for (let w = 0; w < workers.length; w++) {
// add worker
let worker = workers[w];
let row = new wjGrid.GroupRow();
row.dataItem = worker;
row.isReadOnly = false;
row.level = 0;
workersGridRef.current.rows.push(row);
workersGridRef.current.setCellData(row.index, 0, worker.name);
for (let c = 0; c < worker.checks.length; c++) {
// add check
let check = worker.checks[c];
row = new wjGrid.GroupRow();
row.dataItem = check;
row.isReadOnly = false;
row.level = 1;
workersGridRef.current.rows.push(row);
workersGridRef.current.setCellData(row.index, 0, check.name);
for (let e = 0; e < check.earnings.length; e++) {
// add earning
let earning = check.earnings[e];
row = new wjGrid.GroupRow();
row.dataItem = earning;
row.isReadOnly = false;
row.level = 2;
workersGridRef.current.rows.push(row);
workersGridRef.current.setCellData(row.index, 0, earning.name);
workersGridRef.current.setCellData(row.index, 1, earning.hours);
workersGridRef.current.setCellData(row.index, 2, earning.rate);
}
}
}
});
const onBeginningEdit = useEvent((flexGird, e) => {
let value = e.panel.getCellData(e.row, e.col, true);
if (value == null) {
e.cancel = true; // can't edit!
}
});
return (<main className="container-fluid">
<wjcGrid.FlexGrid headersVisibility="Column" selectionMode="Row" beginningEdit={onBeginningEdit} initialized={initialGrid}>
</wjcGrid.FlexGrid>
</main>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Unbound Tree Grid</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
max-height: 220px;
margin: 10px;
}
.wj-cell.wj-group {
border: none;
}
.wj-cell.wj-group:not(.wj-state-selected):not(.wj-state-multi-selected) {
background-color: white;
}
function getWorkers() {
return [{
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jane Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}];
}
export const workers = getWorkers();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjGrid from '@mescius/wijmo.grid';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, AfterViewInit, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
import { DataService } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [WjGridModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements AfterViewInit {
@ViewChild('workersGrid', { static: true }) workersGrid: wjGrid.FlexGrid;
// DataSvc will be passed by derived classes
constructor(@Inject(DataService) private dataService: DataService) {}
//
ngAfterViewInit() {
let workers = this.dataService.getWorkers();
// add columns
this.workersGrid.columns.push(new wjGrid.Column({ header: 'Name' }));
this.workersGrid.columns.push(new wjGrid.Column({ header: 'Hours', dataType: 'Number', format: 'n2' }));
this.workersGrid.columns.push(new wjGrid.Column({ header: 'Rate', dataType: 'Number', format: 'n2' }));
//
// add rows
for (var w = 0; w < workers.length; w++) {
//
// add worker
var worker = workers[w];
var row = new wjGrid.GroupRow();
row.dataItem = worker;
row.isReadOnly = false;
row.level = 0;
this.workersGrid.rows.push(row);
this.workersGrid.setCellData(row.index, 0, worker.name);
for (var c = 0; c < worker.checks.length; c++) {
//
// add check
var check = worker.checks[c];
row = new wjGrid.GroupRow();
row.dataItem = check;
row.isReadOnly = false;
row.level = 1;
this.workersGrid.rows.push(row);
this.workersGrid.setCellData(row.index, 0, check.name);
for (var e = 0; e < check.earnings.length; e++) {
//
// add earning
var earning = check.earnings[e];
row = new wjGrid.GroupRow();
row.dataItem = earning;
row.isReadOnly = false;
row.level = 2;
this.workersGrid.rows.push(row);
this.workersGrid.setCellData(row.index, 0, earning.name);
this.workersGrid.setCellData(row.index, 1, earning.hours);
this.workersGrid.setCellData(row.index, 2, earning.rate);
//
}
}
}
}
//
onBeginningEdit(flexGird: wjGrid.FlexGrid, e: wjGrid.FormatItemEventArgs) {
var value = e.panel.getCellData(e.row, e.col, true);
if (value == null) {
e.cancel = true; // can't edit!
}
}
}
//\\
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Unbound Tree Grid</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main class="container-fluid">
<wj-flex-grid #workersGrid [headersVisibility]="'Column'" [selectionMode]="'Row'"
(beginningEdit)="onBeginningEdit(workersGrid, $event)">
</wj-flex-grid>
</main>
import { Injectable } from '@angular/core';
@Injectable()
export class DataService {
getWorkers() {
return [{
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jack Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}, {
name: 'Jane Smith',
checks: [{
name: 'check1',
earnings: [
{ name: 'hourly', hours: 30.0, rate: 15.0 },
{ name: 'overtime', hours: 10.0, rate: 20.0 },
{ name: 'bonus', hours: 5.0, rate: 30.0 }
]
}, {
name: 'check2',
earnings: [
{ name: 'hourly', hours: 20.0, rate: 18.0 },
{ name: 'overtime', hours: 20.0, rate: 24.0 }
]
}]
}];
}
}
.wj-flexgrid {
max-height: 220px;
margin: 10px;
}
.wj-cell.wj-group {
border: none;
}
.wj-cell.wj-group:not(.wj-state-selected):not(.wj-state-multi-selected) {
background-color: white;
}
body {
margin-bottom: 24px;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);